/* 
   IM Caf - A Java Based Instant Messaging System
   Author: Bruno Freitas - 08/2004
   Contact: bootsector@ig.com.br
 
   Copyright (c) 2004 Bruno Freitas

   Permission is hereby granted, free of charge, to any person obtaining a copy of
   this software and associated documentation files (the "Software"), to deal in 
   the Software without restriction, including without limitation the rights to 
   use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies 
   of the Software, and to permit persons to whom the Software is furnished to do 
   so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in all 
   copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
   SOFTWARE.
*/

import java.awt.*;
import javax.swing.*;

public class IMCafeClient {
   public static void main(String args[]) {
      final String VERSION = "1.0d";
      
      System.out.println("IM Cafe - The Client v" + VERSION + "\nCopyright(c) 08/2004 - Bruno Freitas - bootsector@ig.com.br");
      System.out.println("Starting client program...");
      
      try {
         UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      } catch(Exception e) {
         throw new RuntimeException(e);
      }
      
      Font defFont = new DefaultFont().getFont(Font.PLAIN, 11);
      
      UIManager.put("Label.font", defFont);
      UIManager.put("Button.font", defFont);
      UIManager.put("MenuItem.font", defFont);
      
      ClientMainWindow app = new ClientMainWindow(VERSION);
      
      app.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
   }
}
