/* 
   IM Caf - A Java Based Instant Messaging System
   Author: Bruno Freitas - 08/2004
   Contact: bootsector@ig.com.br
 
   Copyright (c) 2004 Bruno Freitas

   Permission is hereby granted, free of charge, to any person obtaining a copy of
   this software and associated documentation files (the "Software"), to deal in 
   the Software without restriction, including without limitation the rights to 
   use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies 
   of the Software, and to permit persons to whom the Software is furnished to do 
   so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in all 
   copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
   SOFTWARE.
*/

import java.io.*;

public class CommData implements Serializable {
   public static final int CMD_REGISTER_USER = 0;
   public static final int CMD_LOGIN_REQUEST = 1;
   public static final int CMD_LOGIN_GRANTED = 2;
   public static final int CMD_USER_IS_ONLINE = 3;
   public static final int CMD_USER_IS_OFFLINE = 4;
   public static final int CMD_INSTANT_MESSAGE = 5;
   public static final int CMD_ADD_CONTACT_REQ = 6;
   public static final int CMD_ADD_CONTACT_OK = 7;
   public static final int CMD_REMOVE_CONTACT_REQ = 8;
   public static final int CMD_REMOVE_CONTACT_OK = 9;
   public static final int CMD_REQUEST_USER_STATUS = 10;
   public static final int CMD_USER_STATUS_REPLY = 11;
   public static final int CMD_GENERIC_MESSAGE = 12;
   
   private int cmd;
   private int from;
   private int to;
   private int sessionID;
   private String data;
   
   public CommData() {
      this.cmd = -1;
      this.from = -1;
      this.to = -1;
      this.sessionID = -1;
      this.data = null;
   }
   
   public void setCmd(int cmd) {
      this.cmd = cmd;
   }
   
   public void setFrom(int from) {
      this.from = from;
   }
   
   public void setTo(int to) {
      this.to = to;
   }
   
   public void setSessionID(int sessionID) {
      this.sessionID = sessionID;
   }
   
   public void setData(String data) {
      this.data = data;
   }
   
   public int getCmd() {
      return this.cmd;
   }
   
   public int getFrom() {
      return this.from;
   }
   
   public int getTo() {
      return this.to;
   }
   
   public int getSessionID() {
      return this.sessionID;
   }
   
   public String getData() {
      return this.data;
   }
}
