/*==============================================================*/
/* Database name:  IMCAFE.GDB                                   */
/* DBMS name:      InterBase 6.x                                */
/* Created on:     18/8/2004 09:01:36                           */
/*==============================================================*/


SET SQL DIALECT 3;


/*==============================================================*/
/* Database: IMCAFE.GDB                                             */
/*==============================================================*/
create database "IMCAFE.GDB"
user 'SYSDBA'
password 'masterkey'
page_size = 8192;

create generator USER_ID;

/*==============================================================*/
/* Table: OFFLINE_MSGS                                          */
/*==============================================================*/
create table OFFLINE_MSGS (
ID_FROM              INTEGER                        not null,
ID_TO                INTEGER                        not null,
DATE_TIME            TIMESTAMP                      not null,
MSG                  VARCHAR(1024),
constraint PK_OFFLINE_MSGS primary key (ID_FROM, ID_TO, DATE_TIME)
);

/*==============================================================*/
/* Table: ONLINE_USERS                                          */
/*==============================================================*/
create table ONLINE_USERS (
ID                   INTEGER                        not null,
SINCE                TIMESTAMP,
SESSION_ID           INTEGER,
REMOTE_IP            VARCHAR(15),
REMOTE_PORT          INTEGER,
constraint PK_ONLINE_USERS primary key (ID)
);

/*==============================================================*/
/* Table: USERS                                                 */
/*==============================================================*/
create table USERS (
ID                   INTEGER                        not null,
NICKNAME             VARCHAR(30),
FIRST_NAME           VARCHAR(30),
LAST_NAME            VARCHAR(30),
EMAIL                VARCHAR(60),
PASSWD               VARCHAR(30),
constraint PK_USERS primary key (ID)
);

/*==============================================================*/
/* Table: USERS_CONTACTS                                        */
/*==============================================================*/
create table USERS_CONTACTS (
ID                   INTEGER                        not null,
CONTACT              INTEGER                        not null,
constraint PK_USERS_CONTACTS primary key (ID, CONTACT)
);

alter table OFFLINE_MSGS
   add constraint FK_OFFMSGS_FROM_USERS foreign key (ID_FROM)
      references USERS (ID);

alter table OFFLINE_MSGS
   add constraint FK_OFFMSGS_TO_USERS foreign key (ID_TO)
      references USERS (ID);

alter table ONLINE_USERS
   add constraint FK_ONLINE_USERS foreign key (ID)
      references USERS (ID);

alter table USERS_CONTACTS
   add constraint FK_CONTACT_USERS foreign key (CONTACT)
      references USERS (ID);

alter table USERS_CONTACTS
   add constraint FK_USER_USERS foreign key (ID)
      references USERS (ID);

