/* 
   IM Caf - A Java Based Instant Messaging System
   Author: Bruno Freitas - 08/2004
   Contact: bootsector@ig.com.br
 
   Copyright (c) 2004 Bruno Freitas

   Permission is hereby granted, free of charge, to any person obtaining a copy of
   this software and associated documentation files (the "Software"), to deal in 
   the Software without restriction, including without limitation the rights to 
   use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies 
   of the Software, and to permit persons to whom the Software is furnished to do 
   so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in all 
   copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
   SOFTWARE.
*/

import java.sql.*;
import java.util.*;

public class DBInterface {
   private Connection connection;
   
   public DBInterface(String server, String path, String username, String password) throws ClassNotFoundException, SQLException {
      // Note that a Firebird JDBC Driver is already embedded in the JAR file!
      Class.forName("org.firebirdsql.jdbc.FBDriver");
      
      connection = DriverManager.getConnection(
      "jdbc:firebirdsql:" + server + ":" + path,
      username,
      password);
      
      clearOnlineList();
   }
   
   public int addUser(String nick, String fName, String lName, String email,
   String passwd) throws SQLException {
      Statement stmt = connection.createStatement();
      ResultSet rs = stmt.executeQuery("SELECT GEN_ID(USER_ID, 1) FROM " +
      "RDB$DATABASE");
      int user_id;
      
      rs.next();
      
      user_id = rs.getInt(1);
      
      stmt.executeUpdate("INSERT INTO USERS (ID, NICKNAME, FIRST_NAME, " +
      "LAST_NAME, EMAIL, PASSWD) VALUES (" + user_id + ", '" + nick + "', '" +
      fName + "', '" + lName + "', '" + email + "', '" + passwd + "')");
      
      rs.close();
      stmt.close();
      
      return user_id;
   }
   
   public int setUserOnLine(int id, String ip, int port) throws SQLException {
      Statement stmt = connection.createStatement();
      Calendar cal = Calendar.getInstance(TimeZone.getDefault());
      java.text.SimpleDateFormat sdf =
      new java.text.SimpleDateFormat("MM-dd-yyyy HH:mm:ss");
      int session_id = new java.util.Random().nextInt();
      
      sdf.setTimeZone(TimeZone.getDefault());
      
      stmt.executeUpdate("INSERT INTO ONLINE_USERS (ID, SINCE, SESSION_ID, " +
      "REMOTE_IP, REMOTE_PORT) VALUES (" + id + ", '" + sdf.format(cal.getTime()) +
      "', " + session_id + ", '" + ip + "', " + port + ")");
      
      stmt.close();
      
      return session_id;
   }
   
   public void setUserOffLine(int id) throws SQLException {
      Statement stmt = connection.createStatement();
      stmt.executeUpdate("DELETE FROM ONLINE_USERS WHERE ID = " + id);
      stmt.close();
   }
   
   public String getUserPassword(int id) throws SQLException {
      Statement stmt = connection.createStatement();
      ResultSet rs = stmt.executeQuery("SELECT PASSWD FROM USERS WHERE ID = " + id);
      String password;
      
      rs.next();
      password = rs.getString(1);
      
      rs.close();
      stmt.close();
      
      return password;
   }
   
   public String getUserNick(int id) throws SQLException {
      Statement stmt = connection.createStatement();
      ResultSet rs = stmt.executeQuery("SELECT NICKNAME FROM USERS WHERE ID = " + id);
      String nick;
      
      rs.next();
      nick = rs.getString(1);
      
      rs.close();
      stmt.close();
      
      return nick;
   }
   
   public int getUserSessionID(int id) throws SQLException {
      Statement stmt = connection.createStatement();
      ResultSet rs = stmt.executeQuery("SELECT SESSION_ID FROM ONLINE_USERS " +
      "WHERE ID = " + id);
      int session_id;
      
      rs.next();
      session_id = rs.getInt(1);
      
      rs.close();
      stmt.close();
      
      return session_id;
   }
   
   public void addContact(int owner, int contact) throws SQLException {
      Statement stmt = connection.createStatement();
      
      stmt.executeUpdate("INSERT INTO USERS_CONTACTS (ID, CONTACT) VALUES (" +
      owner + ", " + contact + ")");
      
      stmt.close();
   }
   
   public void removeContact(int owner, int contact) throws SQLException {
      Statement stmt = connection.createStatement();
      
      stmt.executeUpdate("DELETE FROM USERS_CONTACTS WHERE ID = " + owner +
      " AND CONTACT = " + contact);
      
      stmt.close();
   }
   
   public String getContactList(int owner, boolean onlineonly) throws SQLException {
      Statement stmt = connection.createStatement();
      ResultSet rs;
      String list = "";
      
      rs = stmt.executeQuery("SELECT USERS_CONTACTS.CONTACT, USERS.NICKNAME " +
      "FROM USERS_CONTACTS " +
      "LEFT JOIN USERS ON USERS_CONTACTS.CONTACT = USERS.ID " +
      "WHERE USERS_CONTACTS.ID = " + owner);
      
      while(rs.next()) {
         if (onlineonly) {
            if (isUserOnLine(rs.getInt(1))) {
               list = list + rs.getString(1) + ":" + rs.getString(2) + ":1,";
            }
         } else {
            list = list + rs.getString(1) + ":" + rs.getString(2) + ":" +
            (isUserOnLine(rs.getInt(1))?1:0) + ",";
         }
      }
      
      rs.close();
      stmt.close();
      
      return list;
   }
   
   public String getOwnersList(int contact, boolean onlineonly) throws SQLException {
      Statement stmt = connection.createStatement();
      ResultSet rs;
      String list = "";
      
      rs = stmt.executeQuery("SELECT USERS_CONTACTS.ID, USERS.NICKNAME " +
      "FROM USERS_CONTACTS " +
      "LEFT JOIN USERS ON USERS_CONTACTS.ID = USERS.ID " +
      "WHERE USERS_CONTACTS.CONTACT = " + contact);
      
      while(rs.next()) {
         if (onlineonly) {
            if (isUserOnLine(rs.getInt(1))) {
               list = list + rs.getString(1) + ":" + rs.getString(2) + ":1,";
            }
         } else {
            list = list + rs.getString(1) + ":" + rs.getString(2) + ":" +
            (isUserOnLine(rs.getInt(1))?1:0) + ",";
         }
      }
      
      rs.close();
      stmt.close();
      
      return list;
   }

   public String getUserIP(int id) throws SQLException {
      Statement stmt = connection.createStatement();
      ResultSet rs;
      String ip = "";
      
      rs = stmt.executeQuery("SELECT ONLINE_USERS.REMOTE_IP FROM ONLINE_USERS " +
      "WHERE ONLINE_USERS.ID = " + id);
      
      rs.next();
      
      ip = rs.getString(1);
      
      rs.close();
      stmt.close();
      
      return ip;
   }
   
   public int getUserPort(int id) throws SQLException {
      Statement stmt = connection.createStatement();
      ResultSet rs;
      int port;
      
      rs = stmt.executeQuery("SELECT ONLINE_USERS.REMOTE_PORT FROM ONLINE_USERS " +
      "WHERE ONLINE_USERS.ID = " + id);
      
      rs.next();
      
      port = rs.getInt(1);
      
      rs.close();
      stmt.close();
      
      return port;
   }
   
   public boolean isUserOnLine(int id) throws SQLException {
      Statement stmt = connection.createStatement();
      ResultSet rs;
      boolean online = false;
      
      rs = stmt.executeQuery("SELECT COUNT(*) FROM ONLINE_USERS " +
      "WHERE ONLINE_USERS.ID = " + id);
      
      rs.next();
      
      if (rs.getInt(1) > 0) online = true;
      
      rs.close();
      stmt.close();
      
      return online;
   }
   
   public int getUserFromConnection(String ip, int port) throws SQLException {
      Statement stmt = connection.createStatement();
      ResultSet rs;
      int id;
      
      rs = stmt.executeQuery("SELECT ONLINE_USERS.ID FROM ONLINE_USERS " +
      "WHERE ONLINE_USERS.REMOTE_IP = '" + ip +
      "' AND ONLINE_USERS.REMOTE_PORT = " + port);
      
      rs.next();
      id = rs.getInt(1);
      
      rs.close();
      stmt.close();
      
      return id;
   }
   
   public boolean ownerHasContact(int owner, int contact) throws SQLException {
      Statement stmt = connection.createStatement();
      ResultSet rs;
      boolean hascontact = false;
      
      rs = stmt.executeQuery("SELECT COUNT(*) FROM USERS_CONTACTS " +
      "WHERE ID = " + owner + " AND CONTACT = " + contact);
      
      rs.next();
      
      if (rs.getInt(1) > 0) hascontact = true;
      
      rs.close();
      stmt.close();
      
      return hascontact;
   }
   
   private void clearOnlineList() {
      try {
         Statement stmt = connection.createStatement();
         stmt.executeUpdate("DELETE FROM ONLINE_USERS");
         stmt.close();
      } catch (Exception e) {
         throw new RuntimeException(e);
      }
   }
   
}
